<?php
/* 
Plugin Name: Nofollow Case by Case 
Plugin URI: http://www.fob-marketing.de/marketing-blog-184-wordpress-nofollow-seo-plugin-nofollow-case-by-case.html 
Description: Nofollow Case by Case allows you to selectively apply rel="nofollow" to your comment links. 
Version: 1.1 
Author: Oliver Bockelmann (fob marketing) 
Author URI: http://www.fob-marketing.de/ 

== Support for Plugin Installer (http://mattread.com/projects/wp-plugins/installer-the-plugin/) == 
Update Server: http://wordpress.org/extend/plugins/nofollow-case-by-case/ 
Min WP Version: 2.0.7 
Max WP Version: 2.1.2 
*/

/*

** Nofollow Case by Case, v. 1.0, 02-21-2007 | Copyright (c) 2007 fob marketing, Hamburg (All rights reserved). 
** This plugin is free software. The plugin is provided "as is" without any warranty. 
** The plugin is GPL Compatible (See http://www.gnu.org/licenses/gpl.html for details.) 

== Plugin Features == 
  * Strip nofollow from comment links (default). 
  * Selectively apply nofollow to any comment link you do not like to support. 
  * Selectively apply nofollow to any comment author link you do not like to support. 

== Installation == 
  1. Upload `nofollow_case_by_case.php` to the `/wp-content/plugins/` directory 
  2. Activate the plugin through the 'Plugins' menu in WordPress 

... Enjoy! 

== How it works == 
If you find links within your comments that you do not like to support
  1. open the comment 
  2. edit '/dontfollow' to that link and 
  3. safe it like that. 

Example: http://www.example.com/dontfollow 

== What happens after modifying the link == 
The link will automatically be changed 
  from: <a href='http://www.example.com/'> 
  to: <a href='http://www.example.com/' rel='nofollow'>

Now the major search engines will not follow this link anymore and 
in the result the page will not receive any pagerank from you. 
Doing so you might have protected yourself against loosing search 
engine trust rank. Trust rank could be lost if you promote spammers 
on your own website. If you don`t want to delete those links use 
nofollow for them. 

*/ 

function make_normal_clickable($ret) { 
	$ret = ' ' . $ret; 
	/* In testing, the WordPress Team found arrays to be faster, so we make use of them from now on: */ 
	$ret = preg_replace( 
		array( 
			/* First two lines make sure that links get a nofollow tag if we want so by adding /dontfollow */ 
			'#([\s>])([\w]+?://[\w\#$%&~/.\-;:=,?@\[\]+]*)/(dontfollow)#is',
			'#([\s>])((www|ftp)\.[\w\#$%&~/.\-;:=,?@\[\]+]*)/(dontfollow)#is',		
			'#([\s>])([\w]+?://[\w\#$%&~/.\-;:=,?@\[\]+]*)#is',
			'#([\s>])((www|ftp)\.[\w\#$%&~/.\-;:=,?@\[\]+]*)#is',
			'#([\s>])([a-z0-9\-_.]+)@([^,< \n\r]+)#i'),
		array(
			'$1<a href="$2" rel="nofollow">$2</a>',
			'$1<a href="http://$2" rel="nofollow">$2</a>',
			'$1<a href="$2">$2</a>',
			'$1<a href="http://$2">$2</a>',
			'$1<a href="mailto:$2@$3">$2@$3</a>'),$ret); 
	/* Make sure that all dontfollow-links where stripped: */ 
	$ret = preg_replace("/\/dontfollow\"/","\" rel=\"nofollow\"",$ret); 
	/* This one is not in an array because we need it to run last, for cleanup of accidental links within links */ 
	$ret = preg_replace("#(<a( [^>]+?>|>))<a [^>]+?>([^>]+?)</a></a>#i", "$1$3</a>",$ret);
	$ret = trim($ret);
	return $ret;
}

/* If you don`t want your comment links to open in a new window delete target=\"blank\" in both functions: */ 

function strip_nofollow($ret) { 
	$ret = preg_replace("/ rel='external nofollow'/","",$ret); 
	$ret = preg_replace("/ rel=\"external nofollow\"/","",$ret); 
	return $ret; 
} 

function make_author_url_nofollow($ret) { 
	$ret = preg_replace("/\/dontfollow'/","' rel=\"nofollow\"",$ret); 
	$ret = preg_replace("/\/dontfollow\"/","\" rel=\"nofollow\"",$ret); 
	return $ret; 
} 

remove_filter('pre_comment_content', 'wp_rel_nofollow', 15); 
remove_filter('comment_text', 'make_clickable'); 
add_filter('comment_text', 'make_normal_clickable'); 
add_filter('get_comment_author_link', 'strip_nofollow'); 
add_filter('get_comment_author_link', 'make_author_url_nofollow'); 
?>